//:DataWriter.java -- defines VRML and POV subclasses of DataWriter
package com.pdx4d.polys;

import java.io.*;

public abstract class DataWriter {
    protected static int[] nubtickoff;
    protected static boolean mute = true;
    public String outfile;
    protected PrintWriter output;
    protected static PrintWriter filehandle;  
    protected boolean filestarted;
    protected DataWriter thisWriter;

    static public PrintWriter openfile(String filename){          
        try{
            filehandle =
              new PrintWriter(
              new BufferedWriter(
              new FileWriter(filename)));
        } catch(Exception e) {System.out.println("Couldn't create file!");}
        return filehandle;
    }
    
    public void writeshape(Shape s, DataWriter writeobj){
        String shapetype = (s.getClass()).getName();  
        System.out.println
        ("Writing object of type: " +shapetype + " to file " + writeobj.outfile);
        // convert to xyz coords if different format (convert back when done)
        if (!writeobj.filestarted){
             writeobj.output = openfile(writeobj.outfile);
             writeobj.writeheader();
             writeobj.filestarted=true;}
        if (shapetype.equals("com.pdx4d.polys.Sphere")){
           writeobj.writesphere(s);}
        else {
           s.convert2xyz();
           writeobj.writeEdges(s);
           if (s.meshed) {
                for (int i=0;i<s.meshes.length;i++)
                   writeobj.writeEdges(s.meshes[i]);
           }
           s.convert2last();
        }
    }

    public void writedone(){
        if (!mute) System.out.println("Close data file");
        output.close();
    }    

    public static void main(String[] args){}

// These methods overwritten in subclasses

    protected void writeheader(){}
    protected void writesphere(Shape s){}
    protected void writesphere
    (double x, double y, double z, double rad, String color){}
    protected void writeEdges(Shape s){}
}


