//:Mesh.java -- extends Shape class
//Abstract class on which Trimesh and Sqrmesh are based

package com.pdx4d.polys;

abstract public class Mesh extends Shape { 
    public double[][] xyzcorners;
    public double curveradius;

    public void setcorners(Shape s,int[] face) {

       xyzcorners = new double[face.length][3];

       for (int i=0;i<face.length;i++){
          for (int j=0;j<3;j++){	
             xyzcorners[i][j] = s.points[face[i]][j];
          }
       }
       double x = xyzcorners[0][0];
       double y = xyzcorners[0][1];
       double z = xyzcorners[0][2];
       curveradius = Math.sqrt(x*x+y*y+z*z);
    }

    public void curve(){
       convert2polar();
       for (int i=0;i<points.length;i++)
          points[i][0]=curveradius;
       convert2xyz();
    }

    public void cymk(){

	convert2quad();

        colorcoded=true;
        rgbcodes = new double[points.length][3];

          for (int i=0;i<points.length;i++){

            double k = points[i][0];
            double y = points[i][1];
            double m = points[i][2];
            double c = points[i][3];	

            // normalize to all values <=1
            double max = c;
            if (y>max) max=y;
            if (m>max) max=m;
            if (k>max) max=k;

            if (max!=0.0){
            c = c/max;
            y = y/max;
            m = m/max;
            k = k/max;
            }

            double r = (y + m)/2.0;
            double g = (c + y)/2.0;
            double b = (c + m)/2.0;

            rgbcodes[i][0]=r;
            rgbcodes[i][1]=g;
            rgbcodes[i][2]=b;
           }
 
        convert2last();
    }

    // overidden by child classes
    public void setfreq(int f){};
    protected void calcpoints(){};
}
