//:Sphere.java -- extends Shape class
package com.pdx4d.polys;


public class Sphere extends Shape {

    public Sphere(){
       radius = 1;
       setcolor("Brown");
       // XYZ volume x Synergetics constant ^3
       shapevolume = SYN3 * (4.0/3.0) * Math.PI;
    }

    public void translate(double[] d){
        if (d.length == 4) d = Formats.quad2xyz(d);
	for (int i=0;i<3;i++) lastpos[i]=pivot[i];
	for (int i=0;i<3;i++) pivot[i]=pivot[i]+d[i];
    }

    public void scale(double scalefactor){
        radius = radius * scalefactor;
        shapevolume = shapevolume * Math.pow(scalefactor,3);
    }
    
    public void rotate(String axis, double degrees){
         if (!mute) System.out.println("Spheres don't need to rotate");
    }

    public static void main(String[] args){}
}

